---
hide:
- toc
---
# Варианты добавления в проект
Есть несколько вариантов добавить фреймворк в проект. Изучите их все и выберете подходящий под ваши задачи.

## Spring Boot Starter
Самый простой способ, если у вас небольшой монолитный Spring Boot проект.

=== ":simple-apachemaven: Maven"

    ```xml
    <dependency>
        <groupId>dev.struchkov.godfather.telegram</groupId>
        <artifactId>telegram-bot-spring-boot-starter</artifactId>
        <version>0.0.50-SNAPSHOT</version>
    </dependency>
    ```

=== ":simple-gradle: Gradle"

    ``` c++
    #include <iostream>

    int main(void) {
      std::cout << "Hello world!" << std::endl;
      return 0;
    }
    ```

## Quarkus Extension

На данный момент раздел находится в разработке.

=== ":simple-apachemaven: Maven"

    ```

    ```

=== ":simple-gradle: Gradle"

    ``` 
    
    ```

### Reactive

На данный момент раздел находится в разработке.

## Основные зависимости проекта
Вы можете добавить основные зависимости в свой проект и сконфигурировать его более тонко под ваши нужды. Однако для этого потребуется хорошее знание архитектуры проекта.

Этот вариант подойдет вам, если у вас используется микросервисная архитектура. Так как логично разделить стадии получения, обработки и отправки сообщений на разные сервисы.

Также этот вариант подойдет вам, если вы используете менее популярный фреймворк, так как основные зависимости написаны без привязки к какому-то конкретному фреймворку.

Всего основных зависимостей три:

=== ":simple-spring: Spring"
    Эти зависимости подойдут вам, если вы используете SpringBoot 3.0.0+

    === ":simple-apachemaven: Maven"

        ``` xml title="Позволяет получать сообщения"
            
        ```
        
        ``` xml title="Содержит всю логику работы"
            
        ```
        
        ``` xml title="Позволяет отправлять сообщения"
            
        ```
    
    === ":simple-gradle: Gradle"

        ``` xml title="Позволяет получать сообщения"
            
        ```
        
        ``` xml title="Содержит всю логику работы"
            
        ```
        
        ``` xml title="Позволяет отправлять сообщения"
            
        ```

=== ":simple-quarkus: Quarkus"

    Эти зависимости подойдут вам, если вы используете Quarkus 2.16.0+

    === ":simple-apachemaven: Maven"

        ``` xml title="Позволяет получать сообщения"
            
        ```
        
        ``` xml title="Содержит всю логику работы"
            
        ```
        
        ``` xml title="Позволяет отправлять сообщения"
            
        ```
    
    === ":simple-gradle: Gradle"

        ``` xml title="Позволяет получать сообщения"
            
        ```
        
        ``` xml title="Содержит всю логику работы"
            
        ```
        
        ``` xml title="Позволяет отправлять сообщения"
            
        ```